
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>淘宝数据库OceanBase SQL编译器部分 源码阅读--解析SQL语法树 / iVAN</title>

    <meta name="description" content="淘宝数据库OceanBase SQL编译器部分 源码阅读--解析SQL语法树 OceanBase是阿里巴巴集团自主研发的可扩展的关系型数据库,实现了跨行跨表的事务,支持数千亿条记录.数百TB数据上的SQL操作.在阿里巴巴集团下,OceanBase数据库支持了多个重要业务的数据存储,包括收藏夹.直通车报表.天猫评价等.截止到2013年4月份,OceanBase线上业务的数据量已经超过一千亿条. 看起来挺厉害的,今天我们来研究下它的源代码.关于OceanBase的架构描述有很多文档,这篇笔记也不打算涉及这些东西,只讨论OceanBase的SQL编译部分的代码. OceanBa">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">淘宝数据库OceanBase SQL编译器部分 源码阅读--解析SQL语法树</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<blockquote><p><strong><br />
OceanBase</strong>是阿里巴巴集团自主研发的可扩展的关系型数据库，实现了跨行跨表的事务，支持数千亿条记录、数百TB数据上的SQL操作。在阿里巴巴集团下，OceanBase数据库支持了多个重要业务的数据存储，包括收藏夹、直通车报表、天猫评价等。截止到2013年4月份，OceanBase线上业务的数据量已经超过一千亿条。</p></blockquote>
<p>看起来挺厉害的,今天我们来研究下它的源代码。关于OceanBase的架构描述有很多文档，这篇笔记也不打算涉及这些东西，只讨论OceanBase的SQL编译部分的代码。</p>
<p>OceanBase是一个开源的数据库,托管在github上,<a href="https://github.com/alibaba/oceanbase" rel="external nofollow noreferrer">点击下载</a>。本文讨论的源码路径对应为：<a href="https://github.com/alibaba/oceanbase/tree/oceanbase_0.3/src/sql" rel="external nofollow noreferrer">oceanbase_0.3/src/sql</a>。最新的版本为0.4，本文讨论的代码基于0.3版本的OceanBase.目前OceanBase的能解析的SQL还比较少，包括Select,Insert,Update,Delete,Show,Explain等.</p>
<p>选择OceanBase 0.3 版本进行学习，基于几个原因：</p>
<ul>
<li>OceanBase 的高质量，高可读性</li>
<li>OceanBase 版本低，没有历史负担</li>
<li>OceanBase SQL解析相对简单，更容易窥见全貌，利于理解设计开发中要解决的主要问题。</li>
<li>与其他数据库的SQL解析部分进行对比，深入理解问题本质</li>
</ul>
<p>该部分主要功能包括了，SQL语句解析，逻辑计划的生成，物理操作符运算等。</p>
<h2>入口：ObSql类</h2>
<p>本部分的入口函数在<strong>ob_sql.h</strong>中,调用函数<strong>ObSql::direct_execute</strong>可以直接执行SQL语句,并返回结果集ObResultSet。函数stmt_prepare用于解析要预编译的SQL语句,stmt_execute则用于执行Prepare过的SQL语句。</p>
<pre> class ObSql
    {
      public:
        ObSql(){}
        ~ObSql(){}
        int direct_execute(const common::ObString &amp;stmt, ObResultSet &amp;result)
        int stmt_prepare(const common::ObString &amp;stmt, ObStmtPrepareResult &amp;result);
        int stmt_execute(const uint64_t stmt_id, const common::ObArray&lt;common::ObObj&gt; params, ObResultSet &amp;result);
        int stmt_close(const uint64_t stmt_id);
    };</pre>
<p>在0.4版本中，direct_execute,stmt_prepare,stmt_execute等函数都被声明为static函数,意味着调用SQL语句执行时可以直接ObSql::direct_execute可以执行SQL语句，而不必再先定义一个ObSql对象。<strong>OceanBase还有年轻，还存在不足，我们阅读源码时应该带着批判思考的精神</strong>。<br />
直接进入direct_execute函数，可以看到整个执行的过程,函数中有很多的if,else语句，主要是因为OceanBase有一个编码规范要求：<strong>一个函数只能有一个返回出口</strong>.按单出口的规范写代码会使得写代码的思路非常清晰，不容易出现内存泄露等问题，在大型项目中还是应该尽量保持函数单出口.当然，我觉得保持一个函数功能简洁、简单易懂也是非常重要的。</p>
<p>在你阅读源码的过程中，遇到的大部分函数都会是这个样.刨去其他干扰信息，结合注释，可以看到，SQL执行分为5个步骤：</p>
<ol>
<li>初始化<br /><code>parse_init(&amp;parse_res)</code></li>
<li>解析SQL语法树<br /><code>parse_sql(&amp;parse_res, stmt.ptr(), static_cast&lt;size_t&gt;(stmt.length()));</code></li>
<li>制定逻辑计划<br /><code>resolve(&amp;logical_plan, parse_res.result_tree_)</code><br /><code>ObMultiPlan* multi_plan = static_cast&lt;ObMultiPlan*&gt;(logical_plan.plan_tree_);</code></li>
<li>生成物理计划：<br /><code>trans.add_logical_plans(multi_plan);</code><br /><code>physical_plan = trans.get_physical_plan(0)</code></li>
<li>执行物理计划：<br /><code>exec_plan-&gt;open()</code></li>
</ol>
<p>初始化仅仅是初始化一个缓冲区，可以略过来研究后面关键的4步。</p>
<h2>解析SQL语法树</h2>
<p>像PostgreSQL,MySQl等一样,OceanBase采用lex和yacc系的词法和语法解析工具生成语法树。GNU下的词法和语法工具为Flex和Bison.Flex利用正则表达式识别SQL语句中的所有词语，Bison则根据类似BNF的语法规则识别SQL语义，从而构建语法树。不熟悉Flex与Bison的同学推荐阅读《FLEX与BISON》(貌似我也没找到其他类似的书籍,^_^)，里面也有专门的一章讲述利用Flex与Bison实现一个简单的SQL分析器。</p>
<p>OceanBase的SQL语法树与PostgreSQL更为相似，但是设计上也有很多区别。</p>
<h3>节点设计</h3>
<p>语法树由一系列的节点串连而成。我选取较为简单的Update语句作为示例，下面是一个例句：<br /><code>Update student set sex="M" where name="小明";</code><br />
其SQL语法树可以表示为：</p>
<blockquote><p>|--Update Stmt<br />|--Table:student<br />|--TargeList:<br />|--sex = "M"<br />|--Qualifications:<br />|--name="小明"</p></blockquote>
<p>语法解析的作用就是如何用数据结构来表示上面这棵语法树。不同的数据库有不同的方案。为加强对比，我选取了PostgreSQL,RedBase与OceanBase作为参照。</p>
<h4>PostgreSQL语法树的节点设计</h4>
<p>PostgreSQL中每一种语法都会有一个对应的结构体，比如更新语句Update对应的结构体为<strong>UpdateStmt</strong>:</p>
<pre>  typedef struct UpdateStmt
{
    NodeTag        type;           /* 枚举类型 */
    RangeVar   *relation;        /* 要更新的关系 */
    List       *targetList;        /* 要更新的项 */
    Node       *whereClause;    /* 更新条件 */
    List       *fromClause;        /* optional from clause for more tables */
    List       *returningList;    /* 返回的表达式列表 */
    WithClause *withClause;        /* WITH clause */
} UpdateStmt;</pre>
<p>其中type是个枚举值,表示结构体的类型,在UpdateStmt中为T_UpdateStmt。其他字段分别对应UPdate语句的各个部分，该结构体可以支持更复杂的Update语句。<br />
PostgreSQL中还有一个基础的结构体：</p>
<pre>typedef struct Node
{
    NodeTag        type;
} Node;</pre>
<p>用于语法解析的结构体都可以强制转换成Node * 类型。PostgreSQL中传递语法结构体是都会转化成Node *类型，只有在需要明确类型的时候根据type枚举值转换成需要的类型。Node *的作用有的类似于void * ,但是更利于调试。我们也可以简单的认为：<strong>诸如UpdateStmt的语法解析结构体们都继承自Node</strong>。</p>
<p>由于每个语法对应一个结构体，因此在PostgreSQL中存在很多类似的结构体，包括SelectStmt,InsertStmt,DeleteStmt等。最终这些结构体还会被统一转换成Query结构体。即Query是统一的语法树结构体。<br />
在PostgreSQL中，示例中的SQL语法树可表示为：</p>
<blockquote><p>|--UpdateStmt<br />|--type: T_UpdateStmt<br />|--relation: student<br />|--targetList:<br />|--targest[0]:<br />|--name: sex<br />|--val: "M"<br />|--whereClause：<br />|--expr: =<br />|--left: name<br />|--right: "小明"</p></blockquote>
<h4>RedBase的语法树的节点设计</h4>
<pre><code>RedBase是斯坦福的数据库系统实现这门课程(cs346)的一个项目。RedBase比起PostgreSQL,OceanBase这样的复杂数据库而言，十分的简单。但是其语法树的节点设计与其他数据库不同，因此提出来做对比。</code></pre>
<pre><code></code></pre>
<pre>typedef struct node{
   NODEKIND kind;/*枚举类型*/

   union{
      /* SM component nodes */
      /* create table node */
      struct{
         char *relname;
         struct node *attrlist;
      } CREATETABLE;

     /*此处省略n多个结构体...*/

      /* QL component nodes */
      /* query node */
      ...

      /* update node */
      struct{
         char *relname;                 /* 关系名 */
         struct node *relattr;          /* 属性 */
         struct node *relorvalue;       /* 修改后值 */
         struct node *conditionlist;    /* 条件列表 */
      } UPDATE;

     /*此处省略n多个结构体...*/
   } u;
} NODE;</pre>
<p>RedBase数据库的语法树结构体只有一个，就是NODE,但是这个NODE结构体的声明有150多行(^-^).NODE包括一个枚举类型,作用于PostgreSQL中的type一样。所有的语法结构如UPDATE,SELECT,CREATETABLE等构成巨大的联合体。针对Update语句的结构体包括了关系名,属性,修改后的值,条件列表等字段，显然这种设计只能支持简单的Update语句。<br />
RedBase采用“巨型”联合体取代PostgreSQL中的多个结构体，免去了类型转换（语法结构体到Node*的转换）。如果把PostgreSQL语法树节点看成是“继承”结构，那么RedBase的语法树节点可以看成是“组合”结构。<br />
在RedBase中，示例中的SQL语法树可表示为：</p>
<blockquote><p>|--NODE:<br />|--kind: N_UPDATE<br />|--u:UPDATE<br />|--relname: student<br />|--relattr:<br />|--kind: N_RELATTR<br />|--u:RELATTR<br />|--relname: (null)<br />|--attrname: sex<br />|--relorvalue:<br />|--kind: N_RELATTR_OR_VALUE<br />|--u:RELATTR_OR_VALUE<br />|--relattr: (null)<br />|--value:<br />|--kind:N_VALUE<br />|--u:VALUE<br />|--sval = "M"<br />|--conditionlist:<br />|--kind:N_LIST<br />|--u: LIST<br />|--next: (null)<br />|--curr:<br />|--kind: N_CONDITION<br />|--u: CONDITION<br />|--lhsRelattr:<br />|--kind: N_RELATTR<br />|--u:RELATTR<br />|--relname: (null)<br />|--attrname: name<br />|--op:<br />|--kind: N_EQ<br />|--rhsRelattr:(null)<br />|--rhsValue:<br />|--kind:N_VALUE<br />|--u:VALUE<br />|--sval = "M"</p></blockquote>
<h4>OceanBase的语法树的节点设计</h4>
<p>OceanBase 的语法树节点结构体也只有一个,该结构体包括一个枚举类型变量type_,和PostgreSQL与RedBase一样，代表该结构体对应的类型。还有两组属性，对应终止符节点,只能使用vakue_和str_value_两个字段，分别对应64位整形值和字符串值；非终止符节点使用最后两个字段,num_child_表示子节点的个数,children_指向子节点数组的首地址。</p>
<pre>typedef struct _ParseNode
{
  ObItemType   type_;

  /* 终止符节点的真实的值 */
  int64_t      value_;
  const char*  str_value_;

  /* 非终止符节点的孩子节点*/
  int32_t      num_child_; /*孩子节点的个数*/
  struct _ParseNode** children_; 

  // BuildPlanFunc m_fnBuildPlan;
} ParseNode;</pre>
<p>对应一个节点而言，要么是终止符节点要么是非终止符节点，它只会使用两组属性中的一组。int,long,float,double,string等都是终止符类型，可以看出int,long都是用64位整形int64表示。float,double,string则用char *字符串表示。终止符的num_child_为0,children_为null.</p>
<p>PostgreSQL的子节点都是有名字的子节点，可以使用名字进行访问，如在PostgreSQL中，Update语句的where条件可以通过 <code><br />
updatestmt.whereClause</code> 来访问 。 但在OceanBase中不行 ， 所有的子节点都是匿名的 ， 只能通过下标来访问。</p>
<blockquote><p>打个比方，在PostgreSQL和RedBase中，孩子是有名字的，可以叫小明、小红等，根据名字你大概可以知道这个孩子是男是女；但是在OceanBase家，他们分别叫老大，老二，老三，听名字完全听不出是男是女的。OceanBase家有点不讲究^-^。</p></blockquote>
<p>可以在运行时查看语法树的结构，也可以在代码中可以推各个子节点代表的类型，但是不如PostgreSQL和RedBase方便。在sql_parser.y文件中，定义了SQL的语法规则，同时也规定了各种类型的子节点的结构。</p>
<pre>update_stmt:
    UPDATE relation_factor SET update_asgn_list opt_where
    {
      ParseNode* assign_list = merge_tree(result-&gt;malloc_pool_, T_ASSIGN_LIST, $4);
      $$ = new_non_terminal_node(result-&gt;malloc_pool_, T_UPDATE, 3, $2, assign_list, $5);
    }
  ;</pre>
<p>从上述代码可以看出，Update语法结构体中有3个子节点，第一个表示表名，第二个表示要更新列表项，第三个表示更新的条件语句。<br />
示例中的Update语句在OceanBase中可以表示为如下形式：</p>
<blockquote><p>|--ParseNode<br />|--type: T_UPDATE<br />|--num_child: 3<br />|--children[0]:<br />|--type: T_IDENT<br />|--str_value: student<br />|--children[1]:<br />|--type: T_ASSIGN_LIST<br />|--num_child:1<br />|--children[0]:<br />|--type: T_ASSIGN_ITEM<br />|--children[0]:<br />|--type: T_IDENT<br />|--str_value: sex<br />|children[1]:<br />|--type: T_EXPR<br />|--children[0]:<br />|--type: T_STRING<br />|--str_value: "M"<br />|--children[2]:<br />|--type: T_OP_EQ<br />|--num_child: 2<br />|--children[0]:<br />|--type: T_IDENT<br />|--str_value: name<br />|--children[1]:<br />|--type: T_IDENT<br />|--str_value: "小明"</p></blockquote>
<p>OceanBase中采用的这种方式缺点很明显，就是使用这些结构体时必须要仔细辨别各个子节点代表的意义，否则容易出错。优点同样也很明显，可以非常灵活的构建出语法树。</p>
<p>语法树的节点的设计，主要是为了解决如何表达语法结构。不同的数据库有不同的具体实现。OceanBase采用终止符和非终止符分类，使用OceanBase的设计极具灵活性，但使用时需要仔细验证，避免出错。</p>
<h3>构建语法树</h3>
<p>SQL的语法规则很多 ， SELECT , INSERT , UPDATE , DELETE , CREATE TABLE 等 dml , ddl 等语句都有对应的语法树。在上一节节中我们已经看到了UPDATE语句在内存中的语法树形状。本节需要些Flex和Bison的基础知识，如果之前没有接触过Flex与Bison的话，可以阅读<strong>《Flex与Bison中文版》</strong>或者<a href="http://blog.csdn.net/sirouni2003/article/details/5906610" rel="external nofollow noreferrer">GNU<br />
 Bison 2.1 中文手册</a>。<br />
SQL全称为结构化查询语言，有独立于各数据库厂家的SQL标准，各数据库基本上都会大体上遵循该标准。像PostgreSQL数据库兼容某些版本的SQL标准，同时也有些自己独有的语句。每个数据库都有自己的擅长之处，这些细微的区别有时候就体现在查询语言的细微区别上。OceanBase在0.3版本仅支持有限的几条SQL语句，按照其官方的介绍，其目标之一是兼容MySQL的语法，让我们拭目以待。</p>
<h4>词法分析</h4>
<p>利用Flex进行词法分析是构建语法树的第一个。Flex源文件包含3部分:选项定义、词法规则、代码部分。选项定义部分定义了该词法分析器使用的特性和一些自定义的函数。词法规则部分为匹配语法+匹配动作。匹配语法为正则表达式，flex从上往下按顺序对每个规则进行匹配，一旦匹配成功则执行该项后面大括号内对应的动作代码;代码部分则是C语言代码。</p>
<p>OceanBase的词法文件为sql_parser.l。其中定义了一些函数，选取部分来看。</p>
<p>下面这两个函数可以使得OceanBase支持转义字符，包括：\b,\f,\n,\r,\t.</p>
<pre>inline unsigned char escaped_char(unsigned char c);

/* quote_type: 0 - single quotes; 1 - double quotation marks */
int64_t parse_string(const char* src, char* dest, int64_t len, int quote_type);</pre>
<p>OceanBase中的字符串用双引号括起来的表示，而且需要进行转义处理。</p>
<pre>\"(\\.|\"\"|[^"\\\n])*\" {
  ParseNode* node = NULL;
  malloc_new_node(node, ((ParseResult*)yyextra)-&gt;malloc_pool_, T_IDENT, 0);
  yylval-&gt;node = node;
  char* src = yytext+1;
  int len = strlen(src) - 1; //remove last quote charactor
  char* dest = (char*) parse_malloc(len + 1, ((ParseResult*)yyextra)-&gt;malloc_pool_);
  check_value(dest);
  node-&gt;str_value_ = dest;
  node-&gt;value_ = parse_string(src, dest, len, 1);/*字符串转义处理*/
  return NAME;
}</pre>
<p>当匹配到NULL时，返回的值类型不能为NULL，因为NULL是c语言的保留字，所以需要换成其他名字，此处将NULL的类型定义为NULLX。</p>
<pre>NULL   {
  /* yylval-&gt;node = new_node(((ParseResult*)yyextra)-&gt;malloc_pool_, T_NULL, 0); */
  malloc_new_node(yylval-&gt;node, ((ParseResult*)yyextra)-&gt;malloc_pool_, T_NULL, 0);
  return NULLX;
}</pre>
<p>再来看关系符号的规则代码，每个符号分别返回一个值。</p>
<pre>"||" {return CNNOP;}
"=" {return COMP_EQ;}
"&gt;=" {return COMP_GE;}
"&gt;" {return COMP_GT;}
"&lt;=" {return COMP_LE;}
"&lt;" {return COMP_LT;}
"!="|"&lt;&gt;" {return COMP_NE;}</pre>
<p>在《Flex与Bison》一书中，作者让所有关系符号返回同一个值，通过yylval的成员值来标记不同符号。代码类型如下这段。</p>
<pre>"=" { yylval.subtok = EXPR_EQ; return COMPARISON; }
"&lt;=&gt;"   { yylval.subtok = EXPR_COMP; return COMPARISON; }
"&gt;="    { yylval.subtok = EXPR_GE; return COMPARISON; }
"&gt;" { yylval.subtok = EXPR_GT; return COMPARISON; }
"&lt;="    { yylval.subtok = EXPR_LE; return COMPARISON; }
"&lt;" { yylval.subtok = EXPR_LT; return COMPARISON; }
"!="    |
"&lt;&gt;"    { yylval.subtok = EXPR_NE; return COMPARISON; }</pre>
<p>虽然都能完成相同的功能，但是从个人喜好来讲，我更喜欢OceanBase这种做法，因为够直接。</p>
<p>整数的值保留在node-&gt;value_中返回，为long long 类型 （ 64位 ） 。 而浮点数的值字面值则保存在node-&gt;str_value_ 中。</p>
<p>接下来，看日期时间的提取。</p>
<pre>Date{whitespace}?'[0-9]{4}(-[0-9]{2}){2}' {
  int year, month, day;
  struct  tm time;
  int ret = 0;

  /* ParseNode* node = new_node(((ParseResult*)yyextra)-&gt;malloc_pool_, T_DATE, 0); */
  ParseNode* node = NULL;
  malloc_new_node(node, ((ParseResult*)yyextra)-&gt;malloc_pool_, T_DATE, 0);
  char* dest = strchr(yytext, '\'');
  dest =  parse_strdup(dest + 1, ((ParseResult*)yyextra)-&gt;malloc_pool_); // skip left quote
  check_value(dest);
  size_t len = strlen(dest);
  dest[len - 1] = '\0'; //remove final '

  node-&gt;str_value_ = dest;//字面值

  ret = sscanf(dest, "%4d-%2d-%2d", &amp;year, &amp;month, &amp;day);
  assert(ret == 3);

  memset(&amp;time, 0, sizeof(struct tm));
  time.tm_year = year - 1900;
  time.tm_mon = month - 1;
  time.tm_mday = day;
  time.tm_hour = 0;
  time.tm_min = 0;
  time.tm_sec = 0;
  time.tm_isdst = -1;

  node-&gt;value_ = mktime(&amp;time) * 1000000L;//转成微秒
  yylval-&gt;node = node;
  return DATE_VALUE;
}</pre>
<p>从表达式中可以看到，OceanBase支持直接传入日期时间，OceanBase也支持Time和Timestamp类型。具体如下表：</p>
<table>
<thead>
<tr>
<th>
类型</th>
<th>
格式(不区分大小写)</th>
<th>
表达式</th>
</tr>
</thead>
<tbody>
<tr>
<td>
Date</td>
<td>
Date 'YYYY-MM-DD'</td>
<td>
Date{whitespace}?'[0-9]{4}(-[0-9]{2}){2}'</td>
</tr>
<tr>
<td>
Time</td>
<td>
Time 'HH:MI:SS.FF'或Time 'HH:MI:SS</td>
<td>
Time{whitespace}?'[0-9]{2}(:[0-9]{2}){2}[.][0-9]{1,6}'，Time{whitespace}?'[0-9]{2}(:[0-9]{2}){2}[.]?'</td>
</tr>
<tr>
<td>
Timestamp</td>
<td>
Timestamp 'YYYY-MM-DD HH:MI:SS.FF'或 Timestamp 'YYYY-MM-DD HH:MI:SS'</td>
<td>
Timestamp{whitespace}?'[0-9]{4}(-[0-9]{2}){2}[ ][0-9]{2}(:[0-9]{2}){2}[.][0-9]{1,6}'，Timestamp{whitespace}?'[0-9]{4}(-[0-9]{2}){2}[ ][0-9]{2}(:[0-9]{2}){2}[.]?'</td>
</tr>
</tbody>
</table>
<p>如下是一个使用日期的示例：</p>
<blockquote><pre><code>select id,name from student where createtime &lt;= date '2014-09-12';</code></pre>
</blockquote>
<p><strong>语法树中存在日期类型的节点,其str_value_存储时间的字面值，value_存储该时间与基准时间（1970年1月1日0时0分0秒）之差的毫秒值。</strong></p>
<p>OceanBase通过拓展标准的SQL语法支持直接在SQL语句中写入时间 ,在词法分析阶段就识别到时间类型，而 PostgreSQL 是在语法分析阶段才会识别时间 。 相比而言 ， OceanBase 这种方式更直观，方便。</p>
<p>在0.4版本的OceanBase中，增加了预编译的功能，需要识别占位符"?",系统变量和用户变量。对应性质如下：</p>
<table>
<thead>
<tr>
<th>
名称</th>
<th>
表达式</th>
<th>
动作代码返回值</th>
</tr>
</thead>
<tbody>
<tr>
<td>
占位符(?)</td>
<td>
<code>"?"</code>
</td>
<td>
QUESTIONMARK</td>
</tr>
<tr>
<td>
系统变量(system_variable)</td>
<td>
<code>(@@[A-Za-z_][A_Za-z0-9_]*)</code>
</td>
<td>
SYSTEM_VARIABLE</td>
</tr>
<tr>
<td>
用户变量(temp_variable)</td>
<td>
<code>(@[A-Za-z_][A_Za-z0-9_]*)</code>
</td>
<td>
TEMP_VARIABLE</td>
</tr>
</tbody>
</table>
<h4>语法分析</h4>
<p>OceanBase的SQL语法文件为sql_parser.y。.y语法文件最终由Bison转为可编译的.c文件。其结构与Flex的.l文件类似，分为选项部分，规则部分和代码部分。下面的代码都是去掉了关联的动作代码的规则语法，这样有助于更专注的理解语法的实现。</p>
<h5>select语法</h5>
<p>在SQL的语句语法中，最复杂的语法莫过于Select语句。我们先来看其在OceanBase中的语法。一个select语句可以使带括号的select语句，也可以使不带括号的select语句：</p>
<pre>select_stmt:
    select_no_parens    %prec UMINUS    /* 不到括号的select语句 */
  | select_with_parens    %prec UMINUS  /* 带括号的select语句 */
  ;</pre>
<blockquote><p>%prec用于交换左右两个标记的优先级和结合性。即select_no_parens与UMINUS互换优先级和结核性，select_with_parens 与UMINUS互换优先级和结核性。UMINUS的定义为<code>%right<br />
 UMINUS</code>。所有上面两句的结果是select_no_parens和select_with_parens都变成了右结合。</p></blockquote>
<p>带括号的select语句可以是只带一个括号，也可以带多对括号：</p>
<pre>select_with_parens:
    '(' select_no_parens ')'      /*只带一个括号*/
  | '(' select_with_parens ')'    /*带多对括号*/
  ;</pre>
<p>不带括号的select语句包括简单的select，带order by排序，带order by排序和limit限制的select语句3种：</p>
<pre>select_no_parens:
    simple_select
  | select_clause order_by
  | select_clause opt_order_by select_limit
  ;</pre>
<p>select子句包括简单slect和带括号的select：</p>
<pre>select_clause:
    simple_select
  | select_with_parens
  ;</pre>
<p><em>为什么不包括不带括号的select,暂时没想通。</em></p>
<p>简单select语句包括我们常见的select 语句，但没有order by和limit选项;同时还包括UNION,INTERSECT,EXCEPT三种运算：</p>
<pre>simple_select:
    SELECT opt_distinct select_expr_list
    FROM from_list
    opt_where opt_groupby opt_having
  | select_clause UNION opt_distinct select_clause
  | select_clause INTERSECT opt_distinct select_clause
  | select_clause EXCEPT opt_distinct select_clause
  ;</pre>
<p>select语句的定义相对其他语句很复杂，而且上面这段代码还没有包括无表的select和for update的select。(这两项在0.4版本的OceanBase中已经实现)。</p>
<p>下面这段是从PostgreSQL9.2.3中截取的Select语法：</p>
<pre>SelectStmt: select_no_parens      %prec UMINUS
      | select_with_parens    %prec UMINUS
    ;

select_with_parens:
      '(' select_no_parens ')'
      | '(' select_with_parens ')'
    ;
select_no_parens:
      simple_select
      | select_clause sort_clause
      | select_clause opt_sort_clause for_locking_clause opt_select_limit
      | select_clause opt_sort_clause select_limit opt_for_locking_clause
      | with_clause select_clause
      | with_clause select_clause sort_clause
      | with_clause select_clause opt_sort_clause for_locking_clause opt_select_limit
      | with_clause select_clause opt_sort_clause select_limit opt_for_locking_clause
    ;

select_clause:
      simple_select
      | select_with_parens
    ;
simple_select:
      SELECT opt_distinct target_list
      into_clause from_clause where_clause
      group_clause having_clause window_clause
      | values_clause
      | TABLE relation_expr
      | select_clause UNION opt_all select_clause
      | select_clause INTERSECT opt_all select_clause
      | select_clause EXCEPT opt_all select_clause
    ;</pre>
<blockquote><p>不知道你是不是有种似曾相识的感觉。没错，在这里，OceanBase借鉴了PostgreSQL的语法分析方式。PostgreSQL号称世界上最优秀的开源数据库，绝非浪得虚名。</p></blockquote>
<h5>update语法</h5>
<p>为保证示例的完整性，我们在来分析下update的语法。</p>
<pre>/*0.3版本的OceanBase*/
update_stmt:
    UPDATE relation_factor SET update_asgn_list opt_where
  ;

update_asgn_list:
    update_asgn_factor
  | update_asgn_list ',' update_asgn_factor
  ;

update_asgn_factor:
    NAME COMP_EQ expr
  ;</pre>
<p>上面为0.3版本中的update的语法，支持常见的update的SQL语句，如果将它和0.4版本的update的语法相比，就会发现：0.4版本的update在set时可以使用保留关键字作为列名，支持hint语法,支持when子句。随着OceanBase逐渐完善，其解析的语法也必然会越来越复杂。<strong>在学习的时候，从一个简单的版本开始，由易到难，就显得很重要。</strong></p>
<p><strong></strong></p>
<pre>/*0.4版本的OceanBase*/
update_stmt:
    UPDATE opt_hint relation_factor SET update_asgn_list opt_where opt_when
  ;
update_asgn_factor:
    column_name COMP_EQ expr
  ;
column_name:
    NAME
  | unreserved_keyword
  ;
opt_when:
    /* EMPTY */
  | WHEN expr
  ;</pre>
<p>除了select，比较复杂还有create table,alter table,expr等。本节最后只讨论表达式的语法问题。其他的不再讨论。</p>
<h4>表达式语法</h4>
<p>expression 是指表达列名或者是一个能够给出真假的布尔表达式。如<br /><code>a+3 &gt; b</code><br /><code>a is not null</code><br />
等等。表达式最常出现在where子句中，用于过滤数据行。</p>
<p>表达式的语法之所以复杂，是因为表达式可以嵌套多个子表达式，多个子表达式出现后可能会出现语法上的歧义。BETWEEN ... AND 用于测试给的表达式是否在给定的范围内，这个操作符中的AND 与逻辑与的AND有歧义。需要使用%prec来改变其优先级和结合性，该方法能奏效，但是PostgreSQL和OceanBase都选择从语法树规则上完全消除该歧义。</p>
<p>OceanBase中表达式有3种类型，分别为<strong>expr , arith_expr , simple_expr</strong>。其中</p>
<ul>
<li><strong>expr</strong> :expr为表达式的核心，是不受约束的表达式，可以直接用于where，having等子句中。</li>
<li><strong>arith_expr</strong> :arith_expr是可以用于between ... and之间的表达式，是受约束的表达式。因此arith_expr是expr的一个真子集。</li>
<li><strong>simple_expr</strong> :simple_expr是简单表达式，不能直接进行自我递归的表达式。是expr和aritharith_expr的共有的部分。</li>
</ul>

<pre>expr_const:
    STRING
  | DATE_VALUE
  | INTNUM
  | APPROXNUM
  | BOOL
  | NULLX
  | QUESTIONMARK
  | TEMP_VARIABLE
  | SYSTEM_VARIABLE
  | SESSION_ALIAS '.' column_name
  ;

simple_expr:
    column_ref
  | expr_const
  | '(' expr ')'
  | '(' expr_list ',' expr ')'
  | case_expr
  | func_expr
  | when_func
  | select_with_parens        %prec UMINUS
  | EXISTS select_with_parens
  ;

/* used by the expression that use range value, e.g. between and */
arith_expr:
    simple_expr
  | '+' arith_expr %prec UMINUS
  | '-' arith_expr %prec UMINUS
  | arith_expr '+' arith_expr
  | arith_expr '-' arith_expr
  | arith_expr '*' arith_expr
  | arith_expr '/' arith_expr
  | arith_expr '%' arith_expr
  | arith_expr '^' arith_expr
  | arith_expr MOD arith_expr 

expr:
    simple_expr
  | '+' expr %prec UMINUS
  | '-' expr %prec UMINUS
  | expr '+' expr
  | expr '-' expr
  | expr '*' expr
  | expr '/' expr
  | expr '%' expr
  | expr '^' expr
  | expr MOD expr
  | expr COMP_LE expr
  | expr COMP_LT expr
  | expr COMP_EQ expr
  | expr COMP_GE expr
  | expr COMP_GT expr
  | expr COMP_NE expr
  | expr LIKE expr
  | expr NOT LIKE expr
  | expr AND expr %prec AND
  | expr OR expr %prec OR
  | NOT expr
  | expr IS NULLX
  | expr IS NOT NULLX
  | expr IS BOOL
  | expr IS NOT BOOL
  | expr IS UNKNOWN
  | expr IS NOT UNKNOWN
  | expr BETWEEN arith_expr AND arith_expr        %prec BETWEEN
  | expr NOT BETWEEN arith_expr AND arith_expr      %prec BETWEEN
  | expr IN in_expr
  | expr NOT IN in_expr
  | expr CNNOP expr
  ;</pre>
<p>simple_expr为简单表达式，并不是说它很简单，因为simple_expr也包含了select_with_parens(带括号的select语句)等语句，只能说simple_expr不能像arith_expr和expr等一样递归调用。</p>
<pre>expr:expr BETWEEN arith_expr AND arith_expr        %prec BETWEEN
  | expr NOT BETWEEN arith_expr AND arith_expr      %prec BETWEEN
  ;</pre>
<p>arith_expr用于between ... and 之间，只包含了算术表达式，没有is,like 以及比较关系表达式。</p>
<p>expr,arith_expr,simple_expr实际上等同于PostgreSQL中的a_expr,b_expr,c_expr。</p>
<p>总之，在语法树规则和词法分析方面，OceanBase大量的借鉴了PostgreSQL。</p>
<h3>节点的创建</h3>
<p>确定了节点的结构和语法树的形状，就到了实际创建语法树的过程。通常,1条SQL语句的语法树存在多个节点，数据库中要高效的执行多条语句，就会遇到大量的节点创建问题。如果每次创建都调用new/malloc等系统函数必然会浪费大量的时，而且还会造成内存碎片。这种问题常常会出现在现实中，各个数据库都有自己不同的解决办法，但基本原理是一次性向系统申请较大的内存，然后在需要的时候自行分配。<br />
接下来我将对比PostgreSQL，RedBase，OceanBase 3个数据库是各自如何解决这一问题的。</p>
<h4>PostgreSQL创建语法树节点</h4>
<p>PostgreSQL使用两个宏完成节点的创建，即makeNode和newNode.</p>
<pre>#define makeNode(_type_)  ((_type_ *) newNode(sizeof(_type_),T_##_type_))

/* 针对gcc版本的newNode */#define newNode(size, tag) \
({    Node *_result; \
    AssertMacro((size) &gt;= sizeof(Node));/* 检测申请的内存大小，&gt;&gt;=sizeof(Node) */ \
    _result = (Node *) palloc0fast(size); /* 申请内存 */ \
    _result-&gt;type = (tag); /*设置TypeTag */ \
    _result; /*返回值*/\
})

#define palloc0fast(sz) \
    ( MemSetTest(0, sz) ? \
        MemoryContextAllocZeroAligned(CurrentMemoryContext, sz) : \
        MemoryContextAllocZero(CurrentMemoryContext, sz) )</pre>
<blockquote><p>注意：要避免直接使用newNode来创建节点，因为节点的大小在不同的环境下可能是不同的。使用makeNode即可，如：<br /><code>Stmt *s = makeNode(Stmt);</code></p></blockquote>
<p>我们知道,PostgreSQL中继承自NODE*的结构体们各自大小不一，都大于等于NODE 的大小。newNode中使用<code>palloc0fast</code>申请内存，它仍然是个宏，最终调用的是PostgreSQL中的<code>MemoryContextAllocZeroAligned</code>或者<code>MemoryContextAllocZero</code>函数，这两个函数来自PostgreSQL中内存管理模块--内存上下文，该模块能够很好的应对内存碎片，向数据库进程提供缓冲区管理。</p>
<h4>RedBase创建语法树节点</h4>
<p>RedBase没有提供向PostgreSQL一样复杂的内存管理机制，而是采用简单的方法来解决频繁创建节点的问题。因为RedBase中语法树的节点都是NODE类型的，所有RedBase使用一个NODE的数组来作为缓冲区，默认最大值为100,超过这个值就会创建出错，并最终退出程序。如果你的SQL语句需要的节点超过100,需要在编译之前修改最大节点数目MAXNODE以适应需求。</p>
<pre>#define MAXNODE        100 //最大节点数目

static NODE nodepool[MAXNODE];
static int nodeptr = 0;

/*
 * newnode: allocates a new node of the specified kind and returns a pointer
 * to it on success.  Returns NULL on error.
 */
NODE *newnode(NODEKIND kind)
{
    NODE *n;

    /* if we've used up all of the nodes then error */
    if(nodeptr == MAXNODE){
    fprintf(stderr, "out of memory\n");
    exit(1);
    }

    /* get the next node */
    n = nodepool + nodeptr;
    ++nodeptr;

    /* initialize the `kind' field */
    n -&gt; kind = kind;
    return n;
}</pre>
<h4>OceanBase创建语法树节点</h4>
<p>OceanBase创建语法树节点的方式与PostgreSQL类似，上层调用，底层有负责内存池管理的模块来负责真正的创建，不过不是内存上下文，而是一个类ObStringBuf.</p>
<p>OceanBase的new_node函数申请内存时调用的是<code>parse_malloc</code>函数，该函数专用于语法树结构体的创建,从obStringBuf中获取内存，直到obStringBuf线程退出时才会真正释放这些内存。</p>
<p>大型的数据库都会有专门的内存管理模块来负责语法程序运行过程中的内存申请和释放，小型的数据库则结合自身特点，量身定制轻量的内存管理机制。目的都只有一个：<strong>降低频繁创建和销毁语法树节点的开销</strong>。</p>
<h2>总结</h2>
<p>SQL的执行包括了解析语法树，制定逻辑查询计划，执行物理查询计划等步骤。通过对比3个不同的数据库的源代码，得出在解析语法树中遇到的一些共性问题：</p>
<ul>
<li>如何表示一个语法树的节点</li>
<li>利用Bison定义语法树的结构时的一些难点，如select,expr等</li>
<li>如何降低频繁创建和销毁语法树节点的开销</li>
</ul>
<p>如果你要自己来写一个SQL解析程序的话，这些问题同样难以避免。</p>
<hr>
<br />欢迎光临<a href="http://www.cxueyou.sinaapp.com/" rel="external nofollow noreferrer">我的网站</a>----<a href="http://www.cnblogs.com/chenxueyou/" rel="external nofollow noreferrer">我的博客园</a>----<a href="http://blog.csdn.net/qq910894904/" rel="external nofollow noreferrer">我的CSDN</a>。<br />
如果阅读本文过程中有任何问题，请<a href="http://mail.qq.com/cgi-bin/qm_share?t=qm_mailme&amp;email=Jx4WFx8eEx4XE2dWVglESEo" rel="external nofollow noreferrer">联系作者</a>，转载请注明出处！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-17 23:57:06</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%ba%91%e6%95%b0%e6%8d%ae%e5%ba%93oceanbase/" title="云数据库Oceanbase">云数据库Oceanbase</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>淘宝数据库OceanBase SQL编译器部分 源码阅读--解析SQL语法树的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9MxWBGb.html" rel="bookmark">淘宝数据库OceanBase SQL编译器部分 源码阅读--生成物理查询计划</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SQL编译解析三部曲分为:构建语法树,制定逻辑计划,生成物理执行计划.前两个步骤请参见我的博客&lt;&lt;淘宝数据库OceanBase SQL编译器部分 源码阅读--解析SQL语法树&gt;&gt;和&lt;&lt;淘宝数据库OceanBase SQL编译器部分 源码阅读--生成逻辑计划&gt;&gt;.这篇博客主要研究第三步,生成物理查询计划. 一. 什么是物理查询计划 与之前的阅读方法一致,这篇博客的两个主要问题是what 和how.那么什么是物理查询计划?物理查询计划能够直接执行并返回数据结果数			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE6PdPM.html" rel="bookmark">淘宝数据库OceanBase SQL编译器部分 源码阅读--生成逻辑计划</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				淘宝数据库OceanBase SQL编译器部分 源码阅读--生成逻辑计划 SQL编译解析三部曲分为:构建语法树,生成逻辑计划,指定物理执行计划.第一步骤,在我的上一篇博客淘宝数据库OceanBase SQL编译器部分 源码阅读--解析SQL语法树里做了介绍,这篇博客主要研究第二步,生成逻辑计划. 一. 什么是逻辑计划? 我们已经知道,语法树就是一个树状的结构组织,每个节点代表一种类型的语法含义.如 update student set sex=&quot;M&quot; where name =&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zGJX6p.html" rel="bookmark">淘宝数据库OceanBase SQL编译器部分 源码阅读--Schema模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				淘宝数据库OceanBase SQL编译器部分 源码阅读--Schema模式 什么是Database,什么是Schema,什么是Table,什么是列,什么是行,什么是User?我们可以可以把Database看作是一个大仓库,仓库分了很多很多的房间,Schema就是其中的房间,一个Schema代表一个房间,Table可以看作是每个Schema中的柜子,行和列就是柜子中的格子.User就是房间的主人.简单来说,Schema是包括表,列,索引,视图等数据库对象的集合. OceanBase中的强Sche			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vMNXXoz.html" rel="bookmark">ASP&period;Net C&num;2&period;0全能数据库组件 &lpar;含下载实例源码地址&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net|数据|数据库|下载 /* ?--------------------------?   | Title: ASP.Net C#2.0全能数据库组件 (开源含实例源码)|   | Project: DBOperatorService.Data                    |   | Subarea: DataSet                                   |   | Author: ξ箫音ξ                           			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMgmPAz.html" rel="bookmark">CI框架源码阅读笔记2 一切的入口 index&period;php</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一节(CI框架源码阅读笔记1 - 环境准备.基本术语和框架流程)中,我们提到了CI框架的基本流程,这里再次贴出流程图,以备参考: 作为CI框架的入口文件,源码阅读,自然由此开始.在源码阅读的过程中,我们并不会逐行进行解释,而只解释核心的功能和实现. 1. 设置应用程序环境 define(&quot;ENVIRONMENT&quot;, &quot;development&quot;); 这里的development可以是任何你喜欢的环境名称(比如dev,再如test),相对应的,你要在下面的switch			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxY4BQp.html" rel="bookmark">Apache Storm源码阅读笔记&amp;amp&semi;OLAP在大数据时代的挑战</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 &lt;一&gt;Apache Storm源码阅读笔记 楔子 自从建了Spark交流的QQ群之后,热情加入的同学不少,大家不仅对Spark很热衷对于Storm也是充满好奇.大家都提到一个问题就是有关storm内部实现机理的资料比较少,理解起来非常费劲. 尽管自己也陆续对storm的源码走读发表了一些博文,当时写的时候比较匆忙,有时候衔接的不是太好,此番做了一些整理,主要是针对TridentTopology部分,修改过的内容采用pdf格式发布,方便打印. 文章中有些内容的理解得益于徐明明和fxjwind两			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1NwWjp.html" rel="bookmark">php中get&lowbar;adjacent&lowbar;post函数PHP源码阅读笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这个函数是wordpress里的一个函数,作用是获取相邻的POST文章. 函数并不大,有效代码大概只有70行左右,但是里面包含的知识不少,所以专门用一篇文章来解释一下. get_adjacent_post函数的源码位于wp-includes/link-template.php中. 我会通过&quot;//roc:&quot;在引出源码阅读笔记. /**  * Retrieve adjacent post.  *  * Can either be next or previous post.  *  * @			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/yMAOQXz.html" rel="bookmark">Flume-NG源码阅读：HBaseSink</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于HBase的sink的所有内容均在org.apache.flume.sink.hbase包下. 每个sink包括自己定制的,都extends AbstractSink implements Configurable. 一.首先是configure(Context context)方法.该方法是对HBaseSink的参数初始化.主要包括以下几个: tableName:要写入的HBase数据表名,不能为空: columnFamily:数据表对应的列簇名,这个sink目前只支持一个列簇,不能为空:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3NooAz.html" rel="bookmark">Flume-NG源码阅读：AvroSink</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				org.apache.flume.sink.AvroSink是用来通过网络来传输数据的,可以将event发送到RPC服务器(比如AvroSource),使用AvroSink和AvroSource可以组成分层结构.它继承自AbstractRpcSink  extends AbstractSink implements Configurable这跟其他的sink一样都得extends AbstractSink implements Configurable,所以重点也在confgure.start.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0B0nz.html" rel="bookmark" class="title">如何实现XML&plus;XSL&plus;javascript数据排序</a>
					<div>
						javascript|xml|排序|数据 如何实现XML+XSL+javascript数据排序 数据排序模版&lt;?xml version=&quot;1.0&quot; encoding=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGQ9oM.html" rel="bookmark" class="title">如何更有效的设置网站标题</a>
					<div>
						虽然很多网站开始重视,但还是有不少网站一点也不了解seo,特别是企业站,尤其是在网站页面标题上的设置最为明显,在这点上很多政府网站也是如此,几乎所有网站页面的标题都是&quot;xx网站&quot;, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEx4Lz.html" rel="bookmark" class="title">ASP删除多个复选项的代码</a>
					<div>
						一种很简单的方法就是把checkbox的名字都写成一样, 到时候接收的时候会接收到用半角&quot;,&quot;分隔的字符串, 然后再用split函数进行分隔,并存到一个数组中, 然后再逐一读出各个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlEQqp.html" rel="bookmark" class="title">用ASP、VB和XML建立互联网应用程序&lpar;2&rpar;</a>
					<div>
						xml|程序|互联网 让我们先分析一下客户端/服务器应用程序.在一个标准的客户端/服务器应用程序中,在应用程序开始时,你能够初始化数据库连接字符串,这就意味着,客户有使用数据库连接字符串的权利,这包括 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPKVoz.html" rel="bookmark" class="title">Sql server复制表结构到一个指定表</a>
					<div>
						问:请问专家,如何复制其它表的结构到一指定的表中去,比如以下的例子: 有如下三个表: 表A:字段1, 字段2, 字段3 表B:字段1, 字段2, 字段3 表C:字段1, 字段2, 字段3 现在想复制A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwl3Xnb.html" rel="bookmark" class="title">Shell中if的基本语法和常见判断用法</a>
					<div>
						  这篇文章主要介绍了Shell中if的基本语法和常见判断用法,本文讲解了if的基本语法.对字符串的判断.对数字的判断.对文件属性的判断.逻辑判断等内容,需要的朋友可以参考下 if, for, whi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgK8L3M.html" rel="bookmark" class="title">VB&period;NET如何将目标工程CPU改为X86</a>
					<div>
						  项目--属性--编译--高级编译选项--目标CPU--改为x86即可					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7lAvb.html" rel="bookmark" class="title">用MTV电子相册软件制作独一无二的相册</a>
					<div>
						什么是MTV电子相册? MTV电子相册属于&quot;软件类型&quot;的电子相册,是指能够达到MTV效果的电子相册.那么,何为MTV?MTV的全称为Music Tlevision,即音乐电视.音乐 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq80Q2b.html" rel="bookmark" class="title">迅雷快鸟停止加速怎么回事</a>
					<div>
						  迅雷快鸟加速失败/停止加速解决办法 加速失败原因通常如下 1.加速请求由于各种原因并没有链接到我们的服务器端 2.速器版本不是我们的新版本. 解决办法: 1.下载最新版迅雷快鸟 2.遇到这样的情况 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZB97z.html" rel="bookmark" class="title">怎么换IP地址&quest;相当简单有效的换IP方法</a>
					<div>
						  随着互联网的越来越普及,网民数量越来越多,各大网站的访问数量的就随之增加,特别是很多任务网站或者注册网站,为了防止恶意的注册等,都会增加访问.点击等等的各种限制,最为普遍的就是IP限制.然而现在很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6e4WWb.html" rel="bookmark" class="title">通过Knockout&period;js &plus; ASP&period;NET Web API构建一个简单的CRUD应用</a>
					<div>
						较之面向最终消费者的网站,企业级Web应用对用户体验的要求要低一些.不过客户对&quot;用户体验&quot;的要求是&quot;与日俱增&quot;的,很多被&quot;惯坏了&quot;的用户已经 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YnERM.html" rel="bookmark" class="title">对内核的直接挂钩</a>
					<div>
						简介          有时在开发中,会遇到这样一种情况,当非常需要对某些内核函数进行挂钩时,而常规基于PE的挂钩,往往达不到目的.在本文中将要探讨的,是怎样直接挂钩内核函数,另外,在示例中,还要演示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgV855b.html" rel="bookmark" class="title">studio-C&num;为什么调试结果和实际运行结果不同？</a>
					<div>
						问题描述 C#为什么调试结果和实际运行结果不同? 用的Microsoft Visual Studio 2010,是关于串口调试助手接收到的数据换行的问题, 在调试的时候都正常,是在每句结尾插入换行符, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLWrdp.html" rel="bookmark" class="title">万网并入阿里云解读：传统主机托管被取代</a>
					<div>
						腾讯科技 王可心 1月7日报道 阿里巴巴集团昨日宣布,旗下的阿里云与万网将合并为新的阿里云公司,合并后&quot;万网&quot;品牌将继续保留,成为阿里云旗下域名服务品牌.这一消息显示,从2011年 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0BoWp.html" rel="bookmark" class="title">在WinForm，自定义类中添加 System&period;Timers&period;Timer控件，为什么不能正常进行</a>
					<div>
						问题描述 在自定义类中加入System.Timers.Timertimergamebegin;System.Timers.Timertimersendpoker;在构造函数中:publicMyClas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqqLwp.html" rel="bookmark" class="title">杭电acm1003 提示Time Limit Exceeded</a>
					<div>
						问题描述 杭电acm1003 提示Time Limit Exceeded #include #include main() { static char arr[20][100000]; int i,j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Jlygz.html" rel="bookmark" class="title">华为的&OpenCurlyDoubleQuote;自我救赎&rdquo;之路</a>
					<div>
						一千个信徒心中有一千个上帝.上帝是可知的还是不可知的?是上帝之手创造了宇宙万物,还是别的冥冥中的意志?数万名科学家以48年的时间,花费了百亿以上的美金,终于隐隐听到了&quot;上帝走近的脚步声&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7xv8qb.html" rel="bookmark" class="title">ibatis中多表联接查询</a>
					<div>
						﻿﻿ 目前,我在做项目的时候,用到了spring + struts2 +ibatis 框架.平时用到的都是一张简单的表,来进行数据的增.删.改.查.而现在突然需要用到其它的一张表,或多张表进行联接查询 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0KLOM.html" rel="bookmark" class="title">通化金马涨停前一群陌生人来营业部&OpenCurlyDoubleQuote;抢票&rdquo;</a>
					<div>
						内幕交易立案追诉新标准公布后,通化资金顶风作案,在重大事项公布前哄抢通化金马至 涨停板,此事被&lt;每日经济新闻&gt; 曝光后,成为众矢之的. 为还原当时情景,&lt;每日经济新闻&gt;记者紧急 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmOA3z.html" rel="bookmark" class="title">插入操作-DB2 中如何将表中数据复制一份，改变表中一个联合主键的值，</a>
					<div>
						问题描述 DB2 中如何将表中数据复制一份,改变表中一个联合主键的值, 如下: 表A有3个字段是联合主键(非自增长) create table A ( a VARCHAR(20) not null,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8Aa0p.html" rel="bookmark" class="title">关于软件二次开发！</a>
					<div>
						问题描述 二次开发可以修改哪些东西呢?主要是调用dll么?是不是完全可以开发出新的一个软件界面呢?可否简单的介绍关于二次开发有哪些资料可以参考?有没有什么书推荐?对已有的某个软件做二次开发,修改界面啊 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk70lrp.html" rel="bookmark" class="title">小学生在课堂闻薄荷味有助提升注意力</a>
					<div>
						如何能让小学生专心听讲一直是令老师们头疼的事情.英国一所小学正把薄荷味和自然界的声音引入课堂,观察这种方法能否提高学生注意力. 薄荷安心 英国格林多大学研究人员在利物浦一所小学开展实验:每天下午上课时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVdLmnM.html" rel="bookmark" class="title">中移动联通激战长沙校园：1元百条短信包月</a>
					<div>
						本报记者蔡胤 实习生周倜 长沙报道 长沙的高校已陆续开学,通信运营商的促销&quot;肉搏&quot;战也开始上演. 记者昨日走访河西高校区发现,今年主要是新势力与动感地带的争锋,双方不仅在&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYdQjxb.html" rel="bookmark" class="title">索尼音乐中国总经理黄小茂离职尚无人接替</a>
					<div>
						黄小茂(资料图片) 本报讯 (记者康沛)昨日记者获悉,原任索尼音乐中国区总经理的黄小茂已于春节前正式离职,改任索尼音乐大中华区总裁崔震东的&quot;特别顾问&quot;一职.据索尼音乐工作人员孙女士 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyKAlkz.html" rel="bookmark" class="title">农业物联网应用及其局限性浅析</a>
					<div>
						智能精准农业的发展,物联网技术在现代农业中的应用正在逐步拓宽,可以实现科学监测.科学种植,促进现代农业发展方式的转变. 一.什么是物联网 到目前为止,业界还没有统一明确的定义,但可以认为它是指在物体中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPOB5vM.html" rel="bookmark" class="title">VBScript使用ADSI为IIS批量添加屏蔽或允许访问的IP&lowbar;vbs</a>
					<div>
						复制代码 代码如下: '/*========================================================================= ' * Intro VB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5OQLAb.html" rel="bookmark" class="title">《看我72变》助coser圆梦</a>
					<div>
						日前,全球首档动漫创意电视真人秀&lt;看我72变&gt;发布会于上海举办,众多明星嘉宾出席发布会,同时也吸引了广大热爱动漫以及游戏角色扮演的动漫迷们的关注.     据介绍,&lt;看我72变&gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2JYRQb.html" rel="bookmark" class="title">山东光伏市场重点在哪？2GW的市场如何分？</a>
					<div>
						北宋末年,硝烟弥漫,108位好汉,聚义梁山,铲奸锄恶,替天行道! 这是&lt;水浒传&gt;的故事,读过该书或者看过相关电视剧的朋友会发现,108位好汉聚义之地为山东,人物大多也是地道的山东人.虽说& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOkWgqz.html" rel="bookmark" class="title">不支持的特性</a>
					<div>
						问题描述 不支持的特性Query:insertintoguestbook1(id,name,email,phone,title,content,time)values(gb_seqq.nextval, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zw57A8M.html" rel="bookmark" class="title">启明星辰泰合安全威胁分析合作计划&mdash;&mdash;合纵连横为安全</a>
					<div>
						以&quot;网络安全同担,网络生活共享&quot;为主题的第三届首都网络安全日活动已经完满落下帷幕.启明星辰为网络安全日活动专设展台,并全程参与展出,更值得一提的是,启明星辰借此机会发布了旨在连接业 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.048 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
